#include "TabDemo1.h"

DATA SECTION
	TabTitle1	db			"Tab1",0
	TabTitle2	db			"Tab2",0
	TabTitle3	db			"Tab3",0
	hInstance	HANDLE		?
	hwnd		HANDLE		?
	hTab		dd			?
	SelTab		dd			0
	hTabDlg		dd 			3 dup ?	

CODE SECTION

START:
	invoke GetModuleHandle, NULL
	mov [hInstance],eax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],IDD_DLG1,NULL,ADDR DlgProc,NULL
	invoke ExitProcess,eax
Tab1Proc FRAME hwnd,uMsg,wParam,lParam
	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab1Proc
		mov	eax,TRUE
		ret
.EndTab1Proc
	mov	eax,FALSE
	ret
endf

Tab2Proc FRAME hwnd,uMsg,wParam,lParam
	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab2Proc
		mov	eax,TRUE
		ret
.EndTab2Proc
	mov	eax,FALSE
	ret
endf
Tab3Proc FRAME hwnd,uMsg,wParam,lParam
	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab3Proc
		mov	eax,TRUE
		ret
.EndTab3Proc
	mov	eax,FALSE
	ret
endf

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL	ts:TC_ITEM
.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_INITDIALOG
		mov	eax,[lParam]
		mov	eax,[eax + NMHDR.code]
		cmp eax,TCN_SELCHANGE
		jne >>.WM_CLOSE	
			INVOKE SendMessage,[hTab],TCM_GETCURSEL,0,0
			cmp eax, [SelTab]
			je >>.WM_CLOSE			
				push eax
				mov	w[ts.mask],	TCIF_PARAM
				INVOKE SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts				
				INVOKE ShowWindow,[ts.lParam],SW_HIDE
				pop	eax
				mov	[SelTab],eax
				INVOKE SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts
				INVOKE ShowWindow,[ts.lParam],SW_SHOWDEFAULT
		jmp >>.EXIT
.WM_INITDIALOG
	int 3
	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_CLOSE

		INVOKE GetDlgItem [hwnd],IDC_TAB1
		mov	D[hTab],eax
		mov	w[ts.mask],	TCIF_TEXT or TCIF_PARAM
		mov	b[ts.lpReserved1],0
		mov	b[ts.lpReserved2],0
		mov	b[ts.iImage],-1
		INVOKE CreateDialogParam,[hInstance],IDD_TAB1,[hTab],addr Tab1Proc,0		
		mov	d[ts.lParam],eax
		mov	d[ts.pszText],OFFSET TabTitle1
		mov	d[ts.cchTextMax],sizeof TabTitle1
		INVOKE SendMessage,[hTab],TCM_INSERTITEM,0,addr ts
		invoke CreateDialogParam,[hInstance],IDD_TAB2,[hTab],addr Tab2Proc,0
		mov	d[ts.lParam],eax
		mov	d[ts.pszText],OFFSET TabTitle2
		mov	d[ts.cchTextMax],sizeof TabTitle2
		invoke SendMessage,[hTab],TCM_INSERTITEM,1,addr ts
		invoke CreateDialogParam,[hInstance],IDD_TAB3,[hTab],addr Tab3Proc,0
		mov	d[ts.lParam],eax
		mov	d[ts.pszText],OFFSET TabTitle3
		mov	d[ts.cchTextMax],sizeof TabTitle3
		invoke SendMessage,[hTab],TCM_INSERTITEM,2,addr ts
		jmp >>.EXIT
.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >>.DEFPROC
		INVOKE EndDialog,[hwnd],NULL
		jmp >>.EXIT
.DEFPROC
	invoke DefWindowProc,[hwnd],[uMsg],[wParam],[lParam]
	mov		eax,FALSE
	ret
.EXIT
	mov eax, TRUE
	ret
ENDF


